config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :products
  get 'home/index'

  get 'home/show/:id', to: 'home#show'

  get 'home/change_language'

  root 'home#index'

end

app/models/product.rb
class Product < ActiveRecord::Base
  translates :description
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

  before_action :set_locale

  def set_locale
    I18n.locale = cookies[:language] || I18n.default_locale
  end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  layout "site"

  def index
    if params[:word] && params[:category]
      @products = Product.where(status: 1)
                          .where("name LIKE ? OR description LIKE ?", "%#{params[:word]}%", "%#{params[:word]}%")
                          .where("category = ?", params[:category])
    elsif params[:word] && !params[:category]
      @products = Product.where(status: 1)
                          .where("name LIKE ? OR description LIKE ?", "%#{params[:word]}%", "%#{params[:word]}%")
    elsif !params[:word] && params[:category]
      @products = Product.where(status: 1)
                          .where("category = ?", params[:category])
    else
      @products = Product.where(status: 1)
    end
  end

  def show
    if params.include?(:id)
      @product = Product.where(id: params[:id])
    end
  end

  def change_language
    if params[:language]
      cookies[:language] = params[:language]
    end
    redirect_to :back
  end

end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
  layout "admin"
  before_action :authenticate_user!
  before_action :set_product, only: [:show, :edit, :update, :destroy]

  # GET /products
  # GET /products.json
  def index
    @products = Product.all
  end

  # GET /products/1
  # GET /products/1.json
  def show
  end

  # GET /products/new
  def new
    @product = Product.new
  end

  # GET /products/1/edit
  def edit
  end

  # POST /products
  # POST /products.json
  def create
    @product = Product.new(product_params)

    respond_to do |format|
      if @product.save
        # Generates sequential SKU of product following standard "SIGLA" + Year and month + Product Id
        @product.sku = "NU-" + Time.now.strftime("%Y%m") + "-" + @product.id.to_s.rjust(5, '0')
        @product.save
        format.html { redirect_to @product, notice: 'Product was successfully created.' }
        format.json { render :show, status: :created, location: @product }
      else
        format.html { render :new }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /products/1
  # PATCH/PUT /products/1.json
  def update
    respond_to do |format|
      if @product.update(product_params)
        format.html { redirect_to @product, notice: 'Product was successfully updated.' }
        format.json { render :show, status: :ok, location: @product }
      else
        format.html { render :edit }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /products/1
  # DELETE /products/1.json
  def destroy
    @product.destroy
    respond_to do |format|
      format.html { redirect_to products_url, notice: 'Product was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_product
      @product = Product.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def product_params
      params.require(:product).permit(:name, :sku, :cover, :description, :category, :status)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
  def productCategory
    [
      ['Ação', 1],
      ['Aventura', 2],
      ['Tiro', 3],
      ['Terror', 4],
      ['Corrida', 5],
      ['Rpg', 6],
      ['Arcade', 7]
    ]
  end

  def productStatus
    [
      ['Não Publicado', 0],
      ['Publicado', 1]
    ]
  end

  def getProductCategory(id_category)
    productCategory[id_category.to_i - 1][0]
  end

  def getProductStatus(id_status)
    productStatus[id_status.to_i][0]
  end
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/products_helper.rb
module ProductsHelper  
end

app/views/home/index.html.erb
<div class="row">
  <div class="col-sm-3 category">
    <ul>
      <li><%= link_to( t('home.all'), "/home/index") %></li>
      <% productCategory.each do |name,id| %>
        <li><%= link_to( "#{name}", "/home/index?category=#{id}") %></li>
      <% end %>
    </ul>
  </div>
  <div class="col-sm-9">
    <h1><%= t("home.title") %></h1>
    <% if @products.length > 0 %>
      <% @products.each do |product| %>
        <%= link_to(image_tag(product.cover, size: "160x210", alt: product.name), "/home/show/#{product.id}") %>
      <% end %>
    <% else %>
      <p class="text-center alert alert-info">
        <%= t('home.nogames') %>
      </p>
    <% end %>
  </div>
</div>

app/views/home/search.html.erb
<h1>Home#index</h1>
<% @products.each do |product| %>
  <%= image_tag(product.cover, size: "160x210", alt: product.name) %>
<% end %>

app/views/home/show.html.erb
<h1><%= @product[0].name %></h1>
<% @product.each do |product| %>
  <div class="row">
    <div class="col-sm-4">
      <%= image_tag(product.cover, size: "320x410", alt: product.name) %>
    </div>
    <div class="col-sm-8">
      <p>
        <h2><%= t('home.description')%></h2>
      </p>
      <p>
        <%= product.description %>
      </p>
      <p>
        <%= link_to(t('home.back'), home_index_path) %>
      </p>
    </div>
  </div>

<% end %>

app/views/layouts/Products.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=Edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title><%= content_for?(:title) ? yield(:title) : "Foostore" %></title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag "application", :media => "all" %>

    <!-- For third-generation iPad with high-resolution Retina display: -->
    <!-- Size should be 144 x 144 pixels -->
    <%= favicon_link_tag 'apple-touch-icon-144x144-precomposed.png', :rel => 'apple-touch-icon-precomposed', :type => 'image/png', :sizes => '144x144' %>

    <!-- For iPhone with high-resolution Retina display: -->
    <!-- Size should be 114 x 114 pixels -->
    <%= favicon_link_tag 'apple-touch-icon-114x114-precomposed.png', :rel => 'apple-touch-icon-precomposed', :type => 'image/png', :sizes => '114x114' %>

    <!-- For first- and second-generation iPad: -->
    <!-- Size should be 72 x 72 pixels -->
    <%= favicon_link_tag 'apple-touch-icon-72x72-precomposed.png', :rel => 'apple-touch-icon-precomposed', :type => 'image/png', :sizes => '72x72' %>

    <!-- For non-Retina iPhone, iPod Touch, and Android 2.1+ devices: -->
    <!-- Size should be 57 x 57 pixels -->
    <%= favicon_link_tag 'apple-touch-icon-precomposed.png', :rel => 'apple-touch-icon-precomposed', :type => 'image/png' %>

    <!-- For all other devices -->
    <!-- Size should be 32 x 32 pixels -->
    <%= favicon_link_tag 'favicon.ico', :rel => 'shortcut icon' %>

    <%= javascript_include_tag "application" %>

    <!-- Le HTML5 shim, for IE6-8 support of HTML elements -->
    <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.2/html5shiv.min.js" type="text/javascript"></script>
    <![endif]-->
  </head>
  <body>

    <div class="navbar navbar-default navbar-static-top">
      <div class="container">
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-responsive-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="#">Foostore</a>
        <div class="navbar-collapse collapse navbar-responsive-collapse">
          <ul class="nav navbar-nav">
            <li><%= link_to "Link1", "/path1"  %></li>
            <li><%= link_to "Link2", "/path2"  %></li>
            <li><%= link_to "Link3", "/path3"  %></li>
          </ul>
        </div>
      </div>
    </div>

    <div class="container">
      <div class="row">
        <div class="col-lg-9">
          <%= bootstrap_flash %>
          <%= yield %>
        </div>
        <div class="col-lg-3">
          <div class="well sidebar-nav">
            <h3>Sidebar</h3>
            <ul class="nav nav-list">
              <li class="nav-header">Sidebar</li>
              <li><%= link_to "Link1", "/path1"  %></li>
              <li><%= link_to "Link2", "/path2"  %></li>
              <li><%= link_to "Link3", "/path3"  %></li>
            </ul>
          </div><!--/.well -->
        </div><!--/span-->
      </div><!--/row-->

      <footer>
        <p>&copy; Company 2016</p>
      </footer>

    </div> <!-- /container -->

  </body>
</html>

app/views/layouts/admin.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Foostore</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>
  <div class="subheader">
    <div class="container slogan">
      <div class="row">
        <div class="col-sm-6">
          <h2>FooStore ­ <%= t('home.slogan') %></h2>
        </div>
        <div class="text-right col-sm-6">
          <%= link_to('Logout', destroy_user_session_path, :method => :delete, class: "logout") %>
        </div>
      </div>
    </div>
  </div>
  <div class="container text-right">
    <%= link_to "Português", home_change_language_path( language: "pt-br") %> |
    <%= link_to "Inglês", home_change_language_path( language: "en") %>
  </div>
  <div class="container">
    <%= yield %>
  </div>
</body>
</html>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Foo Store - <%= t('home.slogan') %> </title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<div class="container">
  <div class="login">
    <%= yield %>
  </div>
</div>


</body>
</html>

app/views/layouts/site.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Foo Store - <%= t('home.slogan') %></title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>
  <div class="subheader">
    <div class="container slogan">
      <h2>FooStore ­ <%= t('home.slogan') %></h2>
    </div>
  </div>
  <div class="container search-bar">
    <div class="row">
      <div class="col-sm-6 text-left">
        <%= form_tag(home_index_path, method: "get") do %>
          <p>
            <input type="text" name="word" value="">
            <input type="submit" value="buscar">
          </p>
        <% end %>
      </div>
      <div class="col-sm-6 text-right">
        <%= link_to "Português", home_change_language_path( language: "pt-br") %> |
        <%= link_to "Inglês", home_change_language_path( language: "en") %>
      </div>
    </div>
  </div>

  <div class="container">
    <%= yield %>
  </div>

</body>
</html>

app/views/products/_form.html.erb
<%= form_for(@product) do |f| %>
  <% if @product.errors.any? %>
    <div id="error_explanation" class="alert alert-danger">
      <h2><%= pluralize(@product.errors.count, "error") %> prohibited this product from being saved:</h2>

      <ul>
      <% @product.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= f.label t('product.form.name') %><br>
    <%= f.text_field :name, {class: "form-control"}%>
  </div>
  <div class="form-group">
    <%= f.label t('product.form.cover') %><br>
    <%= f.text_field :cover, {class: "form-control"} %>
  </div>
  <div class="form-group">
    <%= f.label t('product.form.description') %><br>
    <%= f.text_area :description, {class: "form-control", rows: 6} %>
  </div>
  <div class="form-group">
    <%= f.label t('product.form.category') %><br>
    <%= select(:product, :category, productCategory ) %>
  </div>
  <div class="form-group">
    <%= f.label :status %><br>
    <%= select(:product, :status, productStatus) %>
  </div>
  <div class="actions">
    <%= f.submit(class: "btn btn-success") %>
  </div>
<% end %>

app/views/products/edit.html.erb
<h1><%= t("product.edit.title") %></h1>

<%= render 'form' %>

<%= link_to 'Show', @product %> |
<%= link_to 'Back', products_path %>

app/views/products/index.html.erb
<h1><%= t('product.index.list')%></h1>

<div class="text-right">
  <p>
    <%= link_to 'New Product', new_product_path, {class: "btn btn-success"} %>
  </p>
</div>

<table class="table">
  <thead>
    <tr>
      <th>Cover</th>
      <th>Name</th>
      <th>Sku</th>
      <th>Description</th>
      <th>Category</th>
      <th>Status</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @products.each do |product| %>
      <tr>
        <td><%= image_tag(product.cover, size: "70x100", alt: product.name) %></td>
        <td><%= product.name %></td>
        <td><%= product.sku %></td>
        <td><%= product.description %></td>
        <td><%= getProductCategory(product.category) %></td>
        <td><%= getProductStatus(product.status) %></td>
        <td><%= link_to 'Show', product %></td>
        <td><%= link_to 'Edit', edit_product_path(product) %></td>
        <td><%= link_to 'Destroy', product, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

app/views/products/new.html.erb
<div class="">
  <h1><%= t('product.new.title')%></h1>

  <%= render 'form' %>

  <%= link_to 'Back', products_path %>
</div>

app/views/products/show.html.erb
<p id="notice" class="alert alert-success"><%= notice %></p>

<div class="col-sm-3">
  <%= image_tag(@product.cover, size: "210x300", alt: @product.name) %>
</div>

<p>
  <strong>Name:</strong>
  <%= @product.name %>
</p>

<p>
  <strong>Sku:</strong>
  <%= @product.sku %>
</p>

<p>
  <strong>Description:</strong>
  <%= @product.description %>
</p>

<p>
  <strong>Category:</strong>
  <%= getProductCategory(@product.category) %>
</p>

<p>
  <strong>Status:</strong>
  <%= getProductStatus(@product.status) %>
</p>

<%= link_to 'Edit', edit_product_path(@product) %> |
<%= link_to 'Back', products_path %>